rem Script to automate compiling MEMU for Windows.
rem
rem Run from Visual Studio Developer Command Prompt
echo "Cleaning old compilations"
del /s *.*~
del app\memu\*.o app\memu\*.obj
del dirt\*.o dirt\*.a dirt\*.obj dirt\*.lib
del th\*.o th\*.a th\*.obj th\*.lib
del memu\memu* memu\kernel* memu\*.exe memu\*.dll
for %%f in (boot\*.*) do del memu\%f~nx
echo "Compiling Win32 executables for MEMU"
mkdir memu
cd dirt
copy win32\*.* .
nmake
if errorlevel 1 goto end
cd ..\th
copy win32\*.* .
nmake
if errorlevel 1 goto end
cd ..\app\memu
nmake -f memu-win32.mk clean
nmake -f memu-win32.mk
if errorlevel 1 goto end
cd ..\..
del memu\*.pdb
copy memu.cfg memu
copy *.dll memu
echo "Packaging MEMU runtime for Windows"
mkdir packages
del packages\memu-win32-runtime*.zip
set DSTP=%DATE:~8,2%%DATE:~3,2%%DATE:~0,2%
"C:\Program Files\7-Zip\7z" a -tzip -r0 packages\memu-win32-runtime-%DSTP%.zip memu\*.*
:end
